.nolist
include \masm32\include\masm32rt.inc
.list
.data?
hInst dd ?
.data
ClassName       DB "StdWindow",0
szAppName       DB "test",0
align 4
wc WNDCLASS <CS_HREDRAW or CS_VREDRAW,WndProc,0,0,0,0,0,0,0,ClassName>

.data?
message MSG <>
hwindow dd ? 
hMenu   dd ?
SWidth  dd ?    ; screen width
SHeight dd ?    ; screen height
.code
inv equ invoke
include Printx.inc
Program:
    inv InitCommonControls
    inv GetModuleHandle,0
    mov hInst,eax
    mov wc.hInstance,eax   ; save for later
    inv LoadIcon, 0, IDI_APPLICATION
    mov wc.hIcon,eax
    inv LoadCursor, 0, IDC_ARROW
    mov wc.hCursor,eax
    inv RegisterClass, addr wc
    ;inv LoadMenu, hInst, MNU
    mov hMenu,0;eax
    call GetScreenSetup
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr szAppName,WS_OVERLAPPEDWINDOW,
           0,0,SWidth,SHeight,0,hMenu,hInst,0
    mov hwindow,eax
    inv ShowWindow, hwindow, SW_SHOWNORMAL
    inv UpdateWindow, hwindow
    .repeat
        inv GetMessage,addr message,0,0,0
        .break .if !eax
        inv TranslateMessage,addr message
        inv DispatchMessage,addr message
    .until 0
    inv ExitProcess,message.wParam

GetScreenSetup proc
    inv GetSystemMetrics,SM_CXSCREEN  ; screen width
    mov SWidth,eax
    inv GetSystemMetrics,SM_CYSCREEN
    mov SHeight,eax
	ret
GetScreenSetup endp

.data?
hbrush1 dd ?
hbrush2 dd ?
usevert dd ?
mdc  dd ?   ; memory dc of hidden buffer
mdc2 dd ?   ; scratch for loading images

hbm1 dd ?   ; bitmap for hidden buffer mdc
hbm2 dd ?   ; mdc2
.data
toggle dd 1

.data?
hWin dd ?   ; window handle

hdc    dd ? ; temp dc of dialog
dib1   dd ? ; dibs
dib2   dd ?
mbits1 dd ? ; address of bits
mbits2 dd ?  

crect RECT <>
mwidth  equ crect.right  ; total width of client rectangle in pixels
mheight equ crect.bottom ; total height in pixels

buffx dd 100 dup (?)
.data
mbuff dd offset buffx
bih BITMAPINFOHEADER <sizeof BITMAPINFOHEADER, \
  0,        \;biWidth
  0,        \;biHeight
  1,        \;biPlanes WORD
  32,       \;biBitCount WORD
  BI_RGB,   \;biCompression
  0,        \;biSizeImage
  0,        \;biXPelsPerMeter
  0,        \;biYPelsPerMeter
  0,        \;biClrUsed
  0 >       ;biClrImportant

.code
SetupDibs proc
    pusha

    inv GetClientRect,hWin,addr crect    ; get the size needed for the bitmap
    inv GetDC,hWin  ; get dc's
    mov hdc,eax
    m2m bih.biWidth,mwidth  ; set width and height in bitmapinfoheader
    mov eax,mheight
    neg eax
    mov bih.biHeight,eax
    inv CreateDIBSection,hdc,addr bih,DIB_RGB_COLORS,addr mbits1,0,0
    mov dib1,eax
    inv CreateDIBSection,hdc,addr bih,DIB_RGB_COLORS,addr mbits2,0,0
    mov dib2,eax
    inv ReleaseDC,hWin,hdc

    mov eax,mwidth
    imul eax,mheight    ; get total number of bits

    push eax            ; save
    mov ecx,eax
    mov edi,mbits1
    ;mov eax,002492ffh   ; fill with color
    mov eax,0ff9224h        ; reverse
    rep stosd

    pop ecx             ; get back total number of bits
    mov edi,mbits2
    mov eax,00818181h   ; fill with color
    rep stosd

    inv GdiFlush
sdret:
    popa        
	ret
SetupDibs endp

TimerProc proc hwnd,imsg,tid,ctime  ; timer callback routine.
    inv InvalidateRect,hWin,0,0
	ret
TimerProc endp
WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    local ps:PAINTSTRUCT

    mov eax,uMsg
    .if eax==WM_COMMAND
    .elseif eax==WM_ERASEBKGND
        mov eax,1
        jmp WndRet
    .elseif eax==WM_LBUTTONDOWN
        inv InvalidateRect,hWin,0,0
    .elseif eax==WM_PAINT
        inv BeginPaint,hWnd,ADDR ps
        mov hdc,eax
        .if usevert
        	.if VblankOk
                call WaitForScanLine
        	.endif
        .endif
        neg toggle
        .if sign?
            inv SetDIBitsToDevice,hdc,0,0,mwidth,mheight,0,0,0,mheight,
                    mbits1,addr bih,DIB_RGB_COLORS
        .else
            inv SetDIBitsToDevice,hdc,0,0,mwidth,mheight,0,0,0,mheight,
                    mbits2,addr bih,DIB_RGB_COLORS
        .endif
        call DDGetScanLine  ; get ending scanline
        inv EndPaint,hWnd,ADDR ps
        mov eax,scanLine
        sub eax,WantLine
        printx mbuff,"starting scan line=",dd WantLine," ending scanline=",dd scanLine," scan lines needed=",dd eax
        mov eax,WantLine
        ;.if eax<scanLine
            add WantLine,5
        ;.endif
        inv SetWindowText,hWin,mbuff        
    .elseif eax==WM_SIZE
        .if mdc==0
            call SetupDibs        
            inv SetTimer,hWin,999,50,addr TimerProc
            mov WantLine,1
            not usevert
        .endif
    .elseif eax==WM_CREATE

        m2m hWin,hWnd
        call StartDD    ; set up for vertical blanking
        
    .elseif eax==WM_DESTROY

        inv PostQuitMessage,0
        mov eax,wParam
        jmp WndRet

    .endif
LpExit:
    inv DefWindowProc, hWnd, uMsg, wParam, lParam
WndRet:
	ret
WndProc endp

;-----code to get vertical blanking to prevent flicker from MichaelW------------
uselib ddraw	; to find vertical blanking to prevent flicker

DDO_GetScanLine EQU 64
DDERR_VERTICALBLANKINPROGRESS EQU ((1 shl 31)or(876h shl 16)or(537))

.data
lpdd_1   dd 0
scanLine dd 0
VblankOk dd 0	; flag that it is ok to wait for vertical blanking
WantLine dd 0
MaxLine  dd 0
.code

StartDD proc
    invoke DirectDrawCreate,0,ADDR lpdd_1,0	; Create a default DirectDraw object.
    or eax,eax
    jnz DDNoGood
    call DDGetScanLine	; Make sure DDGetScanLine doesn't have any obvious problems.
    or eax,eax
    jnz DDNoGood
	mov VblankOk,1	; ok to use
    .repeat
        call DDGetScanLine
    .until eax != DDERR_VERTICALBLANKINPROGRESS
    .repeat
        m2m MaxLine,scanLine
        call DDGetScanLine
    .until eax == DDERR_VERTICALBLANKINPROGRESS
	
DDNoGood:   
	ret
StartDD EndP

DDGetScanLine proc
    push offset scanLine
    push lpdd_1
    mov  eax, lpdd_1
    mov  eax, [eax]
    call DWORD PTR[eax+DDO_GetScanLine]
    ret
DDGetScanLine endp

WaitForVerticalBlank proc
    .repeat
        call DDGetScanLine
    .until eax != DDERR_VERTICALBLANKINPROGRESS
    .repeat
        call DDGetScanLine
    .until eax == DDERR_VERTICALBLANKINPROGRESS   
    ret
WaitForVerticalBlank endp
WaitForScanLine proc
    mov eax,WantLine
    .if eax>MaxLine
        mov WantLine,0
    .endif
    .repeat
        call DDGetScanLine
        .if eax != DDERR_VERTICALBLANKINPROGRESS
            mov eax,scanLine
            .break .if eax==WantLine
        .endif
    .until 0

	ret
WaitForScanLine endp
GetErrDescriptionz proc uses ebx edi ; from masm lib, but fixed error
LOCAL hLocal:DWORD, Bufferx[256]:BYTE
.data
ErrMsgTmpl 	db 'Error Code %i',13,10,'%s',0
Unknown 	db 'UnKnown Error',0
.code
    invoke GetLastError
    mov edi,eax
    invoke FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
            0,edi,0,        ; GetItFromSystem, ErrNum, Default language
            addr hLocal,0,0 ; address of string from system, any size, no arguments
    mov ebx,offset Unknown
    .if eax!=0
    	invoke LocalLock,hLocal
    	mov ebx,eax
    .endif
    invoke wsprintf,addr Bufferx,offset ErrMsgTmpl,edi,ebx
    invoke MessageBox,0,addr Bufferx,0,0
    .if ebx!=offset Unknown
    	inv LocalFree,hLocal
	.endif
    ret
GetErrDescriptionz endp

end Program